'use strict';
var fs = require('fs'),
    path = require('path'),
    rimraf = require('rimraf'),
    execProcess = require('child_process').exec;

module.exports = function(dir, expectErrors){
  var testDir = path.join(dir, '/test' + (+new Date()) + parseInt(Math.random() * 1000, 10));
  return{
    exec: function(cmd, callback){
      return execProcess(cmd, {cwd: testDir, timeout: 1000}, function execProcessCallback(err, output, stdError){
        if(err && !expectErrors){
          console.log('AN ERROR OCCURED RUNNING COMMAND `' + cmd + '` in ' + process.cwd() + ':\n');
          if(err) console.log('err:', err);
          if(output) console.log('output:', output);
          if(stdError) console.log('strerr', stdError);
          console.log('---------');
          console.log();
        }
        if(callback) callback(err, output, stdError);
      });
    },
    setupTestFolder: function(){

      fs.mkdirSync(testDir, '0766');
      process.chdir(testDir);

      return {
        path: testDir,
        remove: function(){
          rimraf.sync(testDir);
        }
      };
    }
  };
};